// emote

var db;
var indexedDB = window.indexedDB || window.mozIndexedDB || window.msIndexedDB;
var updating = 0;
var comment_id = 0;

// 正規表現エスケープ
var reRegExp = /[\\^$.*+?()[\]{}|]/g,
	reHasRegExp = new RegExp(reRegExp.source);
function escapeRegExp(string) {
	return (string && reHasRegExp.test(string))
		? string.replace(reRegExp, '\\$&')
		: string;
}

$(function () {
	// emoteのデータベース
	if (indexedDB) {
		
		var openRequest = indexedDB.open("db_emote", 26);
		
		// 初回・バージョン更新時
		openRequest.onupgradeneeded = function (event) {
			updating = 1;
			db = event.target.result;
			//db.deleteObjectStore("tbl_emote");
			var store = db.createObjectStore("tbl_emote", {keyPath: "code"}); // カラム"code"を主キーに設定
		}
		
		openRequest.onsuccess = function (event) {
			db = event.target.result;
			if (updating) {
				setEmoteData("robot.json");
				setEmoteData("global.json");
				// setEmoteData("add.json");    // 追加する場合
			}
		}
		openRequest.onerror = function (event) {
			alert("err: " + openRequest.error );
		}
		
	} else {
		window.alert("IndexedDBが使えないっぽいのでだめです！");
	}

});

// jsonデータ取得
function setEmoteData(file) {
	$.ajax({
		type: 'GET',
		url: file,
		cache: false,
		dataType: 'json',
		success: function(json){
			Object.keys(json).forEach(function (key) {
				var code = key;
				var id = json[key].id;
				add({code: code, id: id});
			});
		}
	});
}

// emote置換コメント
function showComment(mes, stream, cid) {

    // 区切り文字
	var rtag = "[\s\.\!\?,]*";
	var words = mes.split(/[\s\.\!\?,]/);
	
	var codes_replace = [];
	
	// emote画像置換
	words.forEach(function(word) {
		// console.log(word);
		var req = findById(word);
		req.onsuccess = function (event) {
			var result = event.target.result;
			if (result) {
				var code = result['code'];
				var id = result['id'];
				
				if (word === code) {
					console.log("置換1");
					regexp = new RegExp(rtag + '(' + escapeRegExp(code) + ')' + rtag, 'g');
					mes = mes.replace(regexp, '<img src="https://static-cdn.jtvnw.net/emoticons/v1/'+id+'/1.0">');
					$("p#comment-" + cid).html(mes);
				}
			}
		};
		req.onerror = function (event) {
			alert("err: " + req.error );
		}
	});
    
    // 表示
	$('.comment').append('<p id="comment-' + cid + '" class="show stream-' + stream + '">' + mes + "</p>");
    $line = $('#comment-' + cid);
	$line.animate({"marginLeft":"0px"}, 1000, "easeOutCirc"); //easeOutQuint, easeOutBounce
	
	// 非表示
    setTimeout(function(){
        removeComment($('#comment-' + cid), 1000);
	},10000);
    
    chkRemoveComment();
}

// コメントを消す
function removeComment($obj, speed){
	$obj.removeClass("show").animate({"marginTop": -1*$obj.outerHeight()}, speed, function(){
        $(this).remove();
        chkRemoveComment();
    });
}

// ウィンドウサイズから、即座にコメントを消すかどうか判定
function chkRemoveComment() {
    if ($(".show").length == 1) {
        return false
    }
    var sum_height = 0
    $(".show").each(function(){
        sum_height += $(this).outerHeight();
    });
    console.log(sum_height + " / " + window.innerHeight);
    if (sum_height > window.innerHeight) {
        removeComment($(".show:first"), 500);
    }
}

// データベースのデータ追加/更新
function add(data){
	var tran = db.transaction('tbl_emote', 'readwrite');
	var store = tran.objectStore('tbl_emote');
	store.put(data);
}

// データベースから主キーで検索
function findById(code){
	var tran = db.transaction('tbl_emote', 'readonly');
	var store = tran.objectStore('tbl_emote');
	return store.get(code);
}
